export interface LabeledValue<T> {
  value: T;
  label: string;
}

// This should be coming from the apiTypes, but is not implemented yet
export type SortingOrder = 'asc' | 'desc' | 'none';
export type Formatter = 'str' | 'unknown';

export interface Column {
  label: string;
  attribute: string;
  // sorting: SortingOrder;
  formatter?: string;
}

export type GlobalAction = 'add';
export interface ListViewConfig {
  url: string;
  allowedGlobalActions: GlobalAction[];
  searchFormOptions: {
    schools: LabeledValue<string>[];
    activationStates: LabeledValue<string>[];
    roles: LabeledValue<string>[];
    schoolClasses: Record<string, LabeledValue<string>[]>;
  };
  columns: Column[];
}

export type Access = 'none' | 'read' | 'write';
export type Action = 'delete' | 'edit' | 'save' | 'set_password' | 'toggle_active' | 'toggle_wifi';

export interface Attribute {
  value?: unknown;
  access: Access;
}
export interface UserListResponseModel {
  id: string;
  allowedActions: Action[];
  attributes: Record<string, Attribute>;
}
