import {fileURLToPath, URL} from 'node:url';
import {readFile} from 'fs/promises';
import {defineConfig, loadEnv} from 'vite';
import vue from '@vitejs/plugin-vue';

// https://vitejs.dev/config/
export default defineConfig(async({mode}) => {

  const config = {
    plugins: [vue()],
    base: '/univention/ui/ucsschool-users/',
    resolve: {
      alias: {
        '@': fileURLToPath(new URL('./src', import.meta.url)),
      },
    },
  };
  if (mode === 'development') {
    const env = loadEnv(mode, process.cwd(), '');
    if (env.VITE_USE_REAL_BACKEND) {
      appConfig = JSON.parse(await readFile(new URL('./config.json', import.meta.url)));
      config.server = {
        proxy: {
          '/ucsschool/bff-users': {
            target: appConfig['backendURL'],
            changeOrigin: false, // let the bff link back to this proxy in the absolute url values
            secure: false,
          },
        },
      };
    }
  }
  return config;
});
